#include "TI_aes_128.c"

const byte LED = 9;
const byte BLOCK_SIZE = (byte) 16;

  const unsigned char msg[64] = { 0x6b, 0xc1, 0xbe, 0xe2, 0x2e, 0x40, 0x9f,
      0x96, 0xe9, 0x3d, 0x7e, 0x11, 0x73, 0x93, 0x17, 0x2a, 0xae, 0x2d,
      0x8a, 0x57, 0x1e, 0x03, 0xac, 0x9c, 0x9e, 0xb7, 0x6f, 0xac, 0x45,
      0xaf, 0x8e, 0x51, 0x30, 0xc8, 0x1c, 0x46, 0xa3, 0x5c, 0xe4, 0x11,
      0xe5, 0xfb, 0xc1, 0x19, 0x1a, 0x0a, 0x52, 0xef, 0xf6, 0x9f, 0x24,
      0x45, 0xdf, 0x4f, 0x9b, 0x17, 0xad, 0x2b, 0x41, 0x7b, 0xe6, 0x6c,
      0x37, 0x10 };
  
  const unsigned char key[BLOCK_SIZE] = { 0x2b, 0x7e, 0x15, 0x16, 0x28, 0xae,
      0xd2, 0xa6, 0xab, 0xf7, 0x15, 0x88, 0x09, 0xcf, 0x4f, 0x3c };

  unsigned char key_copy[BLOCK_SIZE];
  unsigned char ciphertext[BLOCK_SIZE];

// turn the on-board LED on or off
static void led (bool on) {
  pinMode(LED, OUTPUT);
  digitalWrite(LED, on ? 0 : 1); // inverted logic
}

void setup() {
  pinMode(LED, OUTPUT);
}
static void aes128_block(unsigned const char *key, unsigned const char* plainText, unsigned char *ciphertext, byte encDec) {
  memcpy(ciphertext, plainText, BLOCK_SIZE); // prepare plaintext into output buffer as first step
  memcpy(key_copy, key, BLOCK_SIZE);         // create copy as aes_enc_dec will modify key_copy array
  aes_enc_dec(ciphertext, key_copy, encDec);
}
static void aes128_block_encrypt(unsigned const char *key, unsigned const char* plainText, unsigned char *ciphertext) {
  aes128_block(key, plainText, ciphertext, 0);
}
static void aes128_block_decrypt(unsigned const char *key, unsigned const char* plainText, unsigned char *ciphertext) {
  aes128_block(key, plainText, ciphertext, 1);
}

void loop() {
  led(false);    
  delay(5000);              
  led(true);    
  for (int i = 0; i < 10000; i++) {
    aes128_block_encrypt(key, msg, ciphertext); 
  }
  led(false);   
}
